﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.Services
Imports Microsoft.Crm.Sdk
Imports Microsoft.Crm.SdkTypeProxy
Imports Microsoft.Crm.Sdk.Query
Imports System.Text

' To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
' [System.Web.Script.Services.ScriptService]
<WebService(Namespace:="http://tempuri.org/"), WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1), System.ComponentModel.ToolboxItem(False)>
Public Class CrmServiceWrapper
    Inherits System.Web.Services.WebService

    <WebMethod()>
    Public Function GetCRMData() As String
        ' this will return all users in CRM in a single XML structure.
        Dim xml As New StringBuilder()
        Dim service As CrmService = GetCRMService()

        Dim query As New QueryExpression()
        query.EntityName = "systemuser"
        query.ColumnSet = New AllColumns()

        Dim retrieve As New RetrieveMultipleRequest()
        retrieve.Query = query
        retrieve.ReturnDynamicEntities = False

        Dim retrieved As RetrieveMultipleResponse = CType(service.Execute(retrieve), RetrieveMultipleResponse)

        xml.Append("<Users>")

        For i = 0 To retrieved.BusinessEntityCollection.BusinessEntities.Count - 1
            Dim user As systemuser = CType(retrieved.BusinessEntityCollection.BusinessEntities(i), systemuser)

            ' create a string represenation to return to Silverlight app
            xml.Append("<User")
            xml.Append(" FirstName ='" & user.firstname & "'")
            xml.Append(" LastName = '" & user.lastname & "'")
            xml.Append(" SystemUserId = '" & user.systemuserid.ToString() & "'")
            xml.Append(" JobTitle = '" & user.jobtitle & "'")
            xml.Append("/>")
        Next i

        xml.Append("</Users>")

        Return xml.ToString()
    End Function

    <WebMethod()>
    Public Function PostCRMData(ByVal userId As String, ByVal nickname As String) As String
        Dim service As CrmService = GetCRMService()

        Dim kid As New Key()
        kid.Value = New Guid(userId)
        Dim entity As New systemuser()
        entity.systemuserid = kid

        entity.nickname = nickname

        service.Update(entity)

        Return "success"
    End Function

    Private Shared Function GetCRMService() As CrmService
        Dim service As New CrmService()
        Dim token As CrmAuthenticationToken = New Microsoft.Crm.Sdk.CrmAuthenticationToken()
        token.OrganizationName = "Contoso"
        service.Url = "http://localhost:5555/MSCRMServices/2007/crmservice.asmx"
        service.Credentials = System.Net.CredentialCache.DefaultCredentials
        service.CrmAuthenticationTokenValue = token
        Return service

    End Function
End Class
