﻿
Imports System.Xml.Linq
Imports CRM40SilverlightDemo.CrmServiceWrapper

Partial Public Class MainPage
    Inherits UserControl
    Public Sub New()
        InitializeComponent()

        ' Call the GetCRMData web method
        Dim proxyGet As New CrmServiceWrapperSoapClient()
        AddHandler proxyGet.GetCRMDataCompleted, AddressOf proxy_GetCRMDataCompleted
        proxyGet.GetCRMDataAsync()

        ' Call the PostCRMData web method
        Dim proxyPost As New CrmServiceWrapperSoapClient()
        AddHandler proxyPost.PostCRMDataCompleted, AddressOf proxy_PostCRMDataCompleted
        proxyPost.PostCRMDataAsync("f04b02d9-ad5f-e011-a513-000c29330bd5", "My Nickname")
    End Sub

    ' Called asynchronously when the GetCRMData web method returns data 
    Private Sub proxy_GetCRMDataCompleted(ByVal sender As Object, ByVal e As GetCRMDataCompletedEventArgs)
        Dim xDoc As XDocument = XDocument.Parse(e.Result)

        Dim firstName As String
        Dim lastName As String
        Dim ID As String
        Dim title As String

        ' loop through the results
        For Each element In xDoc.Descendants("User")
            firstName = GetAttributeValue(element, "FirstName")
            lastName = GetAttributeValue(element, "LastName")
            ID = GetAttributeValue(element, "SystemUserId")
            title = GetAttributeValue(element, "JobTitle")
        Next element

    End Sub

    Private Function GetAttributeValue(ByVal element As XElement, ByVal strAttributeName As String) As String
        If element.Attribute(strAttributeName) IsNot Nothing Then
            Return element.Attribute(strAttributeName).Value
        End If
        Return String.Empty
    End Function

    ' Called asynchronously when the PostCRMData web method returns data 
    Private Sub proxy_PostCRMDataCompleted(ByVal sender As Object, ByVal e As PostCRMDataCompletedEventArgs)
        ' do something with the data returned
        Dim result As String = e.Result.ToString()
    End Sub
End Class
